<template>
  <div>
    <div class="hero">
      <div class="container position-relative">
        <div class="hero-content">
          <h1>Women's Summer Collections</h1>
          <p>
            Compellingly fashion cutting-edge portals before exceptional
            meta-services. Completely maintain stand-alone.
          </p>
        </div>
      </div>
      <VueSlickCarousel
        v-if="slick[0].slides.length"
        class="hero-slider"
        v-bind="slick[0].settings"
      >
        <template #default>
          <div
            v-for="(slide, idx) in slick[0].slides"
            :key="idx"
            class="slider-item"
          >
            <img :src="slide.header_img || slide.grid_img" :alt="slide.title" />
            <div class="slider-title">{{ slide.name }}</div>
            <nuxt-link
              :to="`/selections/${
                $store.getters['sitemap/idMap'].selections[slide.id]
              }`"
              class="stretched-link"
            ></nuxt-link>
          </div>
        </template>
        <template #nextArrow>
          <button
            class="slick-next slick-arrow"
            aria-label="Слайдер вперед"
            type="button"
          >
            <i class="icon-arrow-slider"></i>
          </button>
        </template>
        <template #prevArrow>
          <button
            class="slick-prev slick-arrow"
            aria-label="Слайдер назад"
            type="button"
          >
            <i class="icon-arrow-slider"></i>
          </button>
        </template>
      </VueSlickCarousel>
    </div>

    <main class="container">
      <div class="content">
        <div class="heading-wrapper">
          <h3>Explore our Products</h3>
          <base-input
            v-model="controls.search"
            component="search"
            placeholder="Поиск"
            :request-tips="(term) => $store.dispatch('products/onSearch', term)"
            @change="(search) => appendQuery({ search, page: '' })"
          >
          </base-input>
        </div>
        <div class="row">
          <div class="col-md-4 col-lg-3">
            <accordion-filter
              id="accordion-filter-1"
              @submit="(filters) => appendQuery({ ...filters, page: '' })"
              @clear="$router.push({ query: {} })"
            />
            <category-list
              :categories="categories"
              class="list-unstyled d-none d-md-block"
            />
          </div>
          <div class="col-md-8 col-lg-9">
            <div
              class="content-action d-flex align-items-center justify-content-between"
            >
              <dropdown-sort v-once />
              <a href="#mapModal" data-toggle="modal" @click.prevent="openPopup"
                >Показать на карте</a
              >
            </div>

            <div class="product-list row">
              <div
                v-for="product in productItems.results"
                :key="product.id"
                class="col-6 col-lg-4"
              >
                <product-card v-bind="product" />
              </div>
            </div>
            <base-pagination :total-pages="productItems.count_pages" />
          </div>
        </div>
      </div>
      <related-content :slides="slick[1].slides" base-link="selections" />
    </main>

    <!-- Modals-->
    <popup-map v-if="currentPopup" :items="productItems.results" />
  </div>
</template>

<script>
import '@/constants/typedef'
import { mapState } from 'vuex'
import { TypesPopup } from '@/constants/store.types'

import { MAP, HEADER_AUTH } from '@/constants/popups'
import { fetch } from '@/mixins/product'

import AccordionFilter from '@/components/controls/AccordionFilter.vue'
import DropdownSort from '@/components/controls/DropdownSort.vue'
const PopupMap = () => import('@/components/popups/PopupMap.vue')

export default {
  name: 'IndexPage',
  components: {
    AccordionFilter,
    DropdownSort,
    PopupMap,
  },
  mixins: [fetch],
  middleware({ route, store }) {
    if (route.hash === '#auth') {
      store.commit(TypesPopup.mutations.OPEN_POPUP, HEADER_AUTH)
    }
  },
  data() {
    return {
      slick: [
        {
          settings: {
            infinite: true,
            speed: 300,
            slidesToShow: 4,
            slidesToScroll: 1,
            variableWidth: true,
            responsive: [
              {
                breakpoint: 1024,
                settings: {
                  slidesToShow: 2,
                },
              },
              {
                breakpoint: 600,
                settings: {
                  slidesToShow: 1,
                },
              },
              {
                breakpoint: 480,
                settings: {
                  slidesToShow: 1,
                },
              },
            ],
          },
          slides: [],
        },
        {
          settings: {},
          slides: [],
        },
      ],
      controls: {
        search: '',
      },
    }
  },
  fetchOnServer: false,
  async fetch() {
    this.slick[0].slides = (
      await this.$axios.$get('/selections/main-header/')
    ).results
    this.slick[0].settings.slidesToShow =
      this.slick[0].slides.length < 4 ? this.slick[0].slides.length : 4
    this.slick[1].slides = (
      await this.$axios.$get('/selections/recommendations/')
    ).results
  },
  head() {
    return {
      title: this.$route.meta,
    }
  },
  computed: {
    ...mapState({
      currentPopup: (state) => state.popup.currentPopup === MAP,
      categories: (state) => state.categories.categories,
    }),
  },
  methods: {
    openPopup() {
      this.$store.commit(TypesPopup.mutations.OPEN_POPUP, MAP)
    },
  },
}
</script>
